#pragma once

#include "CoreMinimal.h"
#include "MapSpecificGameStateComponent.h"
#include "EGameTypeModifierName.h"
#include "MapSpecificSpawnActorData.h"
#include "MapSpecificSpawnActorsComponent.generated.h"

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class DEADBYDAYLIGHT_API UMapSpecificSpawnActorsComponent : public UMapSpecificGameStateComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	EGameTypeModifierName _shouldSpawnModifier;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TArray<FMapSpecificSpawnActorData> _actorsToSpawn;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_OnLevelReadyToPlay();

public:
	UMapSpecificSpawnActorsComponent();
};

FORCEINLINE uint32 GetTypeHash(const UMapSpecificSpawnActorsComponent) { return 0; }
